CREATE SCHEMA MELVER

-- Historie:
-- 
-- 03.09.2003 - 1.000 (1.008)
-- Schema MELVER in den OKSTRA aufgenommen


CREATE TABLE MELVER (
   MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   hat_administrative_Angaben
      INTEGER NOT NULL REFERENCES administrative_Angaben_MELVER,
   hat_Angaben_zur_Bauleistung
      INTEGER NOT NULL REFERENCES Angaben_zur_Bauleistung_MELVER,
   hat_Angaben_zu_Bew_Biet_Angeb
      INTEGER NOT NULL REFERENCES Angaben_zu_Bew_Biet_Ang_MELVER,
   hat_Angaben_zur_Vergabe
      INTEGER NOT NULL REFERENCES Angaben_zur_Vergabe_MELVER,
   hat_vertragl_Best_und_Massn
      INTEGER NOT NULL REFERENCES vertragl_Best_und_Massn_MELVER,
   hat_Angaben_zur_Auftragssumme
      INTEGER NOT NULL REFERENCES Angaben_z_Auftragssumme_MELVER
)

CREATE TABLE administrative_Angaben_MELVER (
   administrative_Ang_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Bauvertragsnummer
      INTEGER NOT NULL,
   CPV_Nr
      VARCHAR(9) NOT NULL,
   Bezeichnung_der_Bauleistung
      VARCHAR(255) NOT NULL,
   Zusatzfeld
      VARCHAR(2),
   in_Bundesland
      INTEGER NOT NULL REFERENCES Administration.Verwaltungsbezirk_abstrakt,
   hat_Baulasttraeger
      INTEGER NOT NULL REFERENCES Administration.Baulasttraeger,
   in_Baudienststelle
      INTEGER NOT NULL REFERENCES Administration.Strassenbaudienstst_abstr,
   in_Kreis_Gemeinde
      INTEGER NOT NULL REFERENCES Administration.Verwaltungsbezirk_abstrakt,
   hat_Haushalts_Buchungsstelle
      INTEGER NOT NULL REFERENCES Haushalts_Buchungsst_MELVER,
   hat_Bearbeiter
      INTEGER NOT NULL REFERENCES Bearbeiter_MELVER
)

CREATE TABLE Haushalts_Buchungsst_MELVER (
   Haushalts_Buchungsst_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Kapitel
      INTEGER NOT NULL,
   Titel
      INTEGER NOT NULL,
   Funktion
      INTEGER NOT NULL
)

CREATE TABLE Bearbeiter_MELVER (
   Bearbeiter_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Name_Bearbeiter
      VARCHAR(255) NOT NULL,
   Tel_Nr_Bearbeiter
      VARCHAR(255) NOT NULL
)

CREATE TABLE Angaben_zur_Bauleistung_MELVER (
   Ang_z_Bauleistung_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Strassenklasse
      CHAR(1) NOT NULL REFERENCES Strassennetz.Strassenklasse,
   Art_der_Baumassnahme_Phase
      INTEGER NOT NULL REFERENCES Art_der_Baumassnahme_P_MELVER,
   Art_der_Baumassnahme_Bereich
      INTEGER NOT NULL REFERENCES Art_der_Baumassnahme_B_MELVER,
   Bauzeit_in_Monaten
      INTEGER NOT NULL, -- Anzahl_zweistellig
   CHECK ( ( Bauzeit_in_Monaten >= 0 ) AND ( Bauzeit_in_Monaten <= 99 ) )
)

CREATE TABLE Art_der_Baumassnahme_P_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Art_der_Baumassnahme_P_MELVER VALUES (1,'Neubau')
INSERT INTO Art_der_Baumassnahme_P_MELVER VALUES (2,'Ausbau')
INSERT INTO Art_der_Baumassnahme_P_MELVER VALUES (3,'Erhaltung')

CREATE TABLE Art_der_Baumassnahme_B_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Art_der_Baumassnahme_B_MELVER VALUES (1,'Straenbau')
INSERT INTO Art_der_Baumassnahme_B_MELVER VALUES (2,'Kunstbauten')
INSERT INTO Art_der_Baumassnahme_B_MELVER VALUES (3,'Sonstiges')

CREATE TABLE Angaben_zu_Bew_Biet_Ang_MELVER (
   Ang_zu_Bew_Biet_Ang_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Ang_z_Bew_Bie_Ang_MELVER__A_B (
   Angaben_zu_Bew_Biet_Ang_MELVER
      INTEGER NOT NULL REFERENCES Angaben_zu_Bew_Biet_Ang_MELVER,
   Anz_Bewerb_Bieter_Angeb_MELVER
      INTEGER NOT NULL REFERENCES Anz_Bewerb_Bieter_Angeb_MELVER
)

CREATE TABLE Anz_Bewerb_Bieter_Angeb_MELVER (
   Anz_Bew_Bieter_Angeb_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_Bewerber_Bieter_Angebot
      INTEGER NOT NULL REFERENCES Art_Bewerb_Bieter_Angeb_MELVER,
   Region
      INTEGER NOT NULL REFERENCES Region_MELVER,
   Anzahl
      INTEGER NOT NULL, -- Anzahl_zweistellig
   CHECK ( ( Anzahl >= 0 ) AND ( Anzahl <= 99 ) )
)

CREATE TABLE Art_Bewerb_Bieter_Angeb_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Art_Bewerb_Bieter_Angeb_MELVER VALUES (1,'Bewerber bei Teilnahmewettbewerb')
INSERT INTO Art_Bewerb_Bieter_Angeb_MELVER VALUES (2,'Bewerber, an die Vergabeunterlagen abgegeben wurden')
INSERT INTO Art_Bewerb_Bieter_Angeb_MELVER VALUES (3,'Bieter')
INSERT INTO Art_Bewerb_Bieter_Angeb_MELVER VALUES (4,'eingegangene Hauptangebote')
INSERT INTO Art_Bewerb_Bieter_Angeb_MELVER VALUES (5,'eingegangene Nebenangebote')

CREATE TABLE Region_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Region_MELVER VALUES (1,'Deutschland')
INSERT INTO Region_MELVER VALUES (2,'EG')
INSERT INTO Region_MELVER VALUES (3,'Sonstige')

CREATE TABLE Angaben_zur_Vergabe_MELVER (
   Angaben_zur_Vergabe_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Vergabeart
      INTEGER NOT NULL REFERENCES Vergabeart_MELVER,
   Eroeffnung_Angebotsabgabe
      CHAR(10) NOT NULL, -- Datum
   CHECK ( Eroeffnung_Angebotsabgabe LIKE '__.__.____' ),
   Auftragserteilung
      CHAR(10) NOT NULL, -- Datum
   CHECK ( Auftragserteilung LIKE '__.__.____' ),
   Angebotsart
      INTEGER NOT NULL REFERENCES Angebotsart_MELVER,
   Platznummer_Zuschlagsangebot
      INTEGER NOT NULL, -- Anzahl_zweistellig
   CHECK ( ( Platznummer_Zuschlagsangebot >= 0 ) AND ( Platznummer_Zuschlagsangebot <= 99 ) ),
   Erlaeuterung_zur_Vergabeart
      INTEGER NOT NULL REFERENCES Erl_zur_Vergabeart_MELVER,
   hat_Angaben_zum_Auftragnehmer
      INTEGER NOT NULL REFERENCES Ang_zum_Auftragnehmer_MELVER
)

CREATE TABLE Vergabeart_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Vergabeart_MELVER VALUES (10,'.A.')
INSERT INTO Vergabeart_MELVER VALUES (11,'B.A.m.T.')
INSERT INTO Vergabeart_MELVER VALUES (12,'B.A.o.T.')
INSERT INTO Vergabeart_MELVER VALUES (13,'F.V.')
INSERT INTO Vergabeart_MELVER VALUES (14,'R.')
INSERT INTO Vergabeart_MELVER VALUES (15,'N.')
INSERT INTO Vergabeart_MELVER VALUES (20,'O.V.')
INSERT INTO Vergabeart_MELVER VALUES (21,'N.V.')
INSERT INTO Vergabeart_MELVER VALUES (22,'Vv.m.B.')
INSERT INTO Vergabeart_MELVER VALUES (23,'Vv.o.B.')

CREATE TABLE Angebotsart_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Angebotsart_MELVER VALUES (1,'Hauptangebot')
INSERT INTO Angebotsart_MELVER VALUES (2,'Nebenangebot')

CREATE TABLE Erl_zur_Vergabeart_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (31,'4a')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (32,'4b')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (33,'4c')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (34,'5a')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (35,'5b')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (36,'5c')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (37,'5d')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (38,'5e')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (39,'5f')
INSERT INTO Erl_zur_Vergabeart_MELVER VALUES (40,'5g')

CREATE TABLE Ang_zum_Auftragnehmer_MELVER (
   Ang_z_Auftragnehmer_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Name
      VARCHAR(255) NOT NULL,
   Sitz_PLZ
      INTEGER,
   Sitz_in_Land
      CHAR(3) REFERENCES Grunderwerb.Land,
   Art_des_Auftragnehmers
      INTEGER NOT NULL REFERENCES Art_des_Auftragnehmers_MELVER,
   Sitz_in_Bundesland
      INTEGER REFERENCES Administration.Verwaltungsbezirk_abstrakt
)

CREATE TABLE Ang_z_Auftragn_MELVER__w_Namen (
   Ang_zum_Auftragnehmer_MELVER
      INTEGER NOT NULL REFERENCES Ang_zum_Auftragnehmer_MELVER,
   weitere_Namen
      VARCHAR(255) NOT NULL
)

CREATE TABLE Art_des_Auftragnehmers_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Art_des_Auftragnehmers_MELVER VALUES (1,'Einzelunternehmer')
INSERT INTO Art_des_Auftragnehmers_MELVER VALUES (2,'Arbeitsgemeinschaft')

CREATE TABLE vertragl_Best_und_Massn_MELVER (
   vertrgl_Best_u_Massn_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Lohngleitklausel
      INTEGER NOT NULL REFERENCES Logical_Types.Boolean,
   Stoffgleitklausel
      INTEGER NOT NULL REFERENCES Logical_Types.Boolean,
   Vertragsstrafe
      INTEGER NOT NULL REFERENCES Logical_Types.Boolean,
   Nachpruefungsverfahren_eingel
      INTEGER NOT NULL REFERENCES Logical_Types.Boolean,
   Nachpruefungsverfahren_entsch
      INTEGER REFERENCES rechtliche_Instanz_MELVER,
   Zeitdauer_zw_Ruege_u_Entsch
      INTEGER NOT NULL, -- Anzahl_zweistellig
   CHECK ( ( Zeitdauer_zw_Ruege_u_Entsch >= 0 ) AND ( Zeitdauer_zw_Ruege_u_Entsch <= 99 ) ),
   Aenderung_der_Vergabeentsch
      INTEGER NOT NULL REFERENCES Logical_Types.Boolean
)

CREATE TABLE rechtliche_Instanz_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO rechtliche_Instanz_MELVER VALUES (50,'Vergabeprfstelle')
INSERT INTO rechtliche_Instanz_MELVER VALUES (51,'Vergabekammer')
INSERT INTO rechtliche_Instanz_MELVER VALUES (52,'Oberlandesgericht')
INSERT INTO rechtliche_Instanz_MELVER VALUES (53,'Bundesgerichtshof')
INSERT INTO rechtliche_Instanz_MELVER VALUES (54,'Rcknahme')

CREATE TABLE Angaben_z_Auftragssumme_MELVER (
   Ang_z_Auftragssumme_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Auftragssumme
      REAL NOT NULL, -- EURO
   CHECK ( Auftragssumme >= 0 ),
   hat_Summen_bevorzugt_Bewerber
      INTEGER NOT NULL REFERENCES Summe_bevorz_Bewerber_MELVER
)

CREATE TABLE Ang_z_Auftrs_MELVER__S_n_A_d_A (
   Angaben_z_Auftragssumme_MELVER
      INTEGER NOT NULL REFERENCES Angaben_z_Auftragssumme_MELVER,
   Summe_n_Art_der_Arbeit_MELVER
      INTEGER NOT NULL REFERENCES Summe_n_Art_der_Arbeit_MELVER
)

CREATE TABLE A_z_AS_MELVER_h_S_n_U (
   Angaben_z_Auftragssumme_MELVER
      INTEGER NOT NULL REFERENCES Angaben_z_Auftragssumme_MELVER,
   Summe_n_Unternehmensart_MELVER
      INTEGER NOT NULL REFERENCES Summe_n_Unternehmensart_MELVER
)

CREATE TABLE A_z_AS_MELVER_h_S_n_R (
   Angaben_z_Auftragssumme_MELVER
      INTEGER NOT NULL REFERENCES Angaben_z_Auftragssumme_MELVER,
   Summe_nach_Regionen_MELVER
      INTEGER NOT NULL REFERENCES Summe_nach_Regionen_MELVER
)

CREATE TABLE Summe_n_Art_der_Arbeit_MELVER (
   Summe_n_Art_d_Arbeit_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_der_Arbeit
      INTEGER NOT NULL REFERENCES Art_der_Arbeit_MELVER,
   Anteil_Auftragssumme
      REAL NOT NULL, -- EURO
   CHECK ( Anteil_Auftragssumme >= 0 )
)

CREATE TABLE Art_der_Arbeit_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Art_der_Arbeit_MELVER VALUES (1,'Abbrucharbeiten')
INSERT INTO Art_der_Arbeit_MELVER VALUES (2,'Erdarbeiten')
INSERT INTO Art_der_Arbeit_MELVER VALUES (3,'Arbeiten fr Kunstbauten')
INSERT INTO Art_der_Arbeit_MELVER VALUES (4,'Oberbauarbeiten')
INSERT INTO Art_der_Arbeit_MELVER VALUES (5,'Arbeiten fr Straenausstattungen')
INSERT INTO Art_der_Arbeit_MELVER VALUES (6,'Sonstige Arbeiten')

CREATE TABLE Summe_n_Unternehmensart_MELVER (
   Summe_n_Unternehmart_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_des_Unternehmens
      INTEGER NOT NULL REFERENCES Art_des_Unternehmens_MELVER,
   Anteil_Auftragssumme
      REAL NOT NULL, -- EURO
   CHECK ( Anteil_Auftragssumme >= 0 )
)

CREATE TABLE Art_des_Unternehmens_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Art_des_Unternehmens_MELVER VALUES (1,'Growirtschaft')
INSERT INTO Art_des_Unternehmens_MELVER VALUES (2,'Mittelstand')

CREATE TABLE Summe_nach_Regionen_MELVER (
   Summe_nach_Regionen_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Region
      INTEGER NOT NULL REFERENCES Region_MELVER,
   Anteil_Auftragssumme
      REAL NOT NULL, -- EURO
   CHECK ( Anteil_Auftragssumme >= 0 )
)

CREATE TABLE Summe_bevorz_Bewerber_MELVER (
   Summe_bevorz_Bew_MELVER_ID
      INTEGER NOT NULL PRIMARY KEY,
   Anteil_Auftragssumme
      REAL NOT NULL, -- EURO
   CHECK ( Anteil_Auftragssumme >= 0 ),
   Grund_der_Bevorzugung
      INTEGER NOT NULL REFERENCES Grund_der_Bevorzugung_MELVER,
   Auftragskriterium
      INTEGER NOT NULL REFERENCES Auftragskriterium_MELVER,
   gewaehrter_Mehrpreis
      REAL NOT NULL, -- EURO
   CHECK ( gewaehrter_Mehrpreis >= 0 )
)

CREATE TABLE Grund_der_Bevorzugung_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Grund_der_Bevorzugung_MELVER VALUES (1,'Anerkannte Werksttten fr Behinderte')
INSERT INTO Grund_der_Bevorzugung_MELVER VALUES (2,'Blindenwerksttten')

CREATE TABLE Auftragskriterium_MELVER (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Auftragskriterium_MELVER VALUES (1,'wirtschaftlichstes Angebot')
INSERT INTO Auftragskriterium_MELVER VALUES (2,'Eintrittsrecht mit Mehrpreisgewhrung')
